# 1 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F" 1
!--------------------------------------------------------------------------------------------------!
!   CP2K: A general program to perform molecular dynamics simulations                              !
!   Copyright 2000-2025 CP2K developers group <https://cp2k.org>                                   !
!                                                                                                  !
!   SPDX-License-Identifier: GPL-2.0-or-later                                                      !
!--------------------------------------------------------------------------------------------------!

! **************************************************************************************************
!> \brief CP2K+SMEAGOL interface.
!> \author Sergey Chulkov
!> \author Christian Ahart
!> \author Clotilde Cucinotta
! **************************************************************************************************
MODULE smeagol_emtoptions
# 1 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/input_cp2k_smeagol.fypp" 1
# 7 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/input_cp2k_smeagol.fypp"
# 325 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/input_cp2k_smeagol.fypp"
# 16 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F" 2
   USE cell_types, ONLY: cell_type, &
                         scaled_to_real
   USE cp_dbcsr_api, ONLY: dbcsr_get_info, &
                           dbcsr_type
#if defined(__SMEAGOL)
   USE global_meshvar, ONLY: smeagolglobal_orbital_BS => orbital_BS
#endif
   USE input_constants, ONLY: smeagol_gridmethod_adaptive, &
                              smeagol_gridmethod_traditional, &
                              smeagol_integraltype_gauss_chebyshev, &
                              smeagol_integraltype_gauss_legendre
   USE kinds, ONLY: default_string_length, &
                    dp
#if defined(__SMEAGOL)
   USE mbfield, ONLY: smeagolglobal_ZeemanBx => ZeemanBx, &
                      smeagolglobal_ZeemanBy => ZeemanBy, &
                      smeagolglobal_ZeemanBz => ZeemanBz
#endif
   USE message_passing, ONLY: mp_para_env_type
#if defined(__SMEAGOL)
   USE mselfenergies, ONLY: SetOptionsSelfEnergies
   USE negfcoop, ONLY: coopinfo
   USE negfmod, ONLY: &
# 40 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_dsigmade => dsigmade, &
# 40 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_calcmpsh => calcmpsh, &
# 42 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
# 43 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_NeneT => NeneT, &
# 43 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_rmoinit => rmoinit, &
# 43 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_rmolast => rmolast, &
# 43 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_rorbinit => rorbinit, &
# 43 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_rorblast => rorblast, &
# 45 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
# 46 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_maxkappa => maxkappa, &
# 48 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
# 49 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_TEnergI => TEnergI, &
# 49 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_TEnergF => TEnergF, &
# 49 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_vgate => vgate, &
# 51 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
# 52 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_zgater => zgater, &
# 52 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_zgatel => zgatel, &
# 52 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_alphag => alphag, &
# 54 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
# 55 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_timereversal => timereversal, &
# 55 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_TRCAddVCDFT => TRCAddVCDFT, &
# 55 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_AddVgCompensatingIsolatedLocalCharges => AddVgCompensatingIsolatedLocalCharges, &
# 55 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_Add_Rho_Gate => Add_Rho_Gate, &
# 55 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_debug_gate => debug_gate, &
# 55 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_empdoskso => empdoskso, &
# 55 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_emtimings => emtimings, &
# 57 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
# 58 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_ik_select => ik_select, &
# 60 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
# 61 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_Q_gate => Q_gate, &
# 63 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
# 64 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_RGlxmin => RGlxmin, &
# 64 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_RGlxmax => RGlxmax, &
# 64 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_RGlymin => RGlymin, &
# 64 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_RGlymax => RGlymax, &
# 64 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_RGlzmin => RGlzmin, &
# 64 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_RGlzmax => RGlzmax, &
# 66 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_pdosgs => pdosgs, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_skipright => skipright, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_sigmatodisk => sigmatodisk, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_bs_add => bs_add, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_bs_writetrc => bs_writetrc, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_writetk => writetk, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_setene => setene, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_overwritehs => overwritehs, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_transmembed => transmembed, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_writeevsigma => writeevsigma, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_skiptransm => skiptransm, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_deauto => deauto, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_geterrsigma => geterrsigma, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_getsigma => getsigma, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_trcef => trcef, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_RhoSetZeroIfHZero => RhoSetZeroIfHZero, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_m_usehinv => m_usehinv, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_m_usevinv => m_usevinv, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_m_callsvd => m_callsvd, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_m_complexbands => m_complexbands, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_m_dosleads => m_dosleads, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_leadsdos => leadsdos, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_leadspdos => leadspdos, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_emldos => emldos, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_emldos2 => emldos2, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_curr_distKEne => curr_distKEne, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_curr_distK => curr_distK, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_curr_dist => curr_dist, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_curr_distTRC => curr_distTRC, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_em_NonSCF => em_NonSCF, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_TransmissionRL => TransmissionRL, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_emSTTk => emSTTk, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_GetT0S => GetT0S, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_TransmissionChannels => TransmissionChannels, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_TransmissionChannelsWFS => TransmissionChannelsWFS, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_TransmissionMatrix => TransmissionMatrix, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_TransmissionMatrixWFS => TransmissionMatrixWFS, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_TransmissionMatrixPDOS => TransmissionMatrixPDOS, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_EM_EndCode1 => EM_EndCode1, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_TransmOverk => TransmOverk, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_emdos => emdos, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_empdos => empdos, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_empdosk => empdosk, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_WriteIkTrcK => WriteIkTrcK, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_cbspart => cbspart, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_evec => evec, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_negfon => negfon, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_outinfo => outinfo, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_WriteNk => WriteNk, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_Set_RhoBoundary_Leads => Set_RhoBoundary_Leads, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_Set_RhoBoundaryOverlap_Leads => Set_RhoBoundaryOverlap_Leads, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_Set_HBoundary_Leads => Set_HBoundary_Leads, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_Set_HLR_Zero => Set_HLR_Zero, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_SkipNonEquilibriumRho => SkipNonEquilibriumRho, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_SkipEquilibriumRho => SkipEquilibriumRho, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_ComputeImpurityGfMatsubara => ComputeImpurityGfMatsubara, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_PrintImpurityGfMatsubara => PrintImpurityGfMatsubara, &
# 67 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_CallImpuritySolver => CallImpuritySolver, &
# 69 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_maxdepth => maxdepth, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_ndivisions => ndivisions, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_storesigma => storesigma, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_bs_method => bs_method, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_bs_nmid => bs_nmid, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_NRunSigmaMax => NRunSigmaMax, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_bsrun => bsrun, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_bsskip => bsskip, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_bseskip => bseskip, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_bssc => bssc, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_inversion_solver => inversion_solver, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_onekp => onekp, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_nbss => nbss, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_nSplit => nSplit, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_TransmissionChannelsWFSSkipEne => TransmissionChannelsWFSSkipEne, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_TransmissionChannelsWFSSkipKP => TransmissionChannelsWFSSkipKP, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_TransmissionMatrixPDOSNWrite => TransmissionMatrixPDOSNWrite, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_TransmissionMatrixiSetPhase => TransmissionMatrixiSetPhase, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_MinChannelIndex => MinChannelIndex, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_MaxChannelIndex => MaxChannelIndex, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_N_Replace_L => N_Replace_L, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_N_Replace_R => N_Replace_R, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_curr_nb1 => curr_nb1, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_curr_nb2 => curr_nb2, &
# 70 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_NParallelK => NParallelK, &
# 72 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
# 73 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_GetRhoSingleLead => GetRhoSingleLead, &
# 75 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_bs_tol => bs_tol, &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_bs_min  => bs_min , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_HSTol  => HSTol , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_deltaimag  => deltaimag , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_deltaini  => deltaini , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_deltatode  => deltatode , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_critam  => critam , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_setemin  => setemin , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_setemax  => setemax , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_tolab  => tolab , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_weightrho  => weightrho , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_ThetaLeadsL  => ThetaLeadsL , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_PhiLeadsL  => PhiLeadsL , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_ThetaLeadsR  => ThetaLeadsR , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_PhiLeadsR  => PhiLeadsR , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_deltaimagtrc  => deltaimagtrc , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_m_tolki  => m_tolki , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_m_svdtolmax  => m_svdtolmax , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_m_svdtolmin  => m_svdtolmin , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_m_dsigmamax  => m_dsigmamax , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_m_rnoise  => m_rnoise , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_m_skipsvd  => m_skipsvd , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_m_svdtolzi  => m_svdtolzi , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_SigmaWideBand  => SigmaWideBand , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_emSTTkScale  => emSTTkScale , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_nlSetZeroRatio  => nlSetZeroRatio , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_nrSetZeroRatio  => nrSetZeroRatio , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_curr_fl_L  => curr_fl_L , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_curr_fr_L  => curr_fr_L , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_curr_fl_R  => curr_fl_R , &
# 76 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_curr_fr_R  => curr_fr_R , &
# 78 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
# 79 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_deltamin => deltamin, &
# 81 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
# 82 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_tolsigma => tolsigma, &
# 82 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_trcde => trcde, &
# 84 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_deltabss_bs => deltabss_bs, &
      smeagolglobal_gamma_negf => gamma_negf, &
      smeagolglobal_emforces => emforces, &
      smeagolglobal_emSTT => emSTT, &
      smeagolglobal_emSTTLin => emSTTLin, &
      smeagolglobal_gridmethod => gridmethod, &
      smeagolglobal_integraltype => integraltype, &
      smeagolglobal_ndivxy => ndivxy, &
      smeagolglobal_ndivxyNL => ndivxyNL, &
      smeagolglobal_negf_base_comm => negf_base_comm, &
      smeagolglobal_nebss_bs => nebss_bs, &
      smeagolglobal_nprocs_hs => nprocs_hs
   USE sigma, ONLY: &
# 98 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
      smeagolglobal_sigma_method => sigma_method
# 100 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
#endif
      USE smeagol_control_types, ONLY: smeagol_control_type
      USE string_utilities, ONLY: integer_to_string
#include "./base/base_uses.f90"

      IMPLICIT NONE
      PRIVATE

      CHARACTER(len=*), PARAMETER, PRIVATE :: moduleN = 'smeagol_emtoptions'

      PUBLIC :: reademtr, ReadOptionsNEGF_DFT, emtrans_options, emtrans_deallocate_global_arrays

   CONTAINS

      SUBROUTINE reademtr(smeagol_control, natoms, gamma_negf)
         TYPE(smeagol_control_type), POINTER                :: smeagol_control
         INTEGER, INTENT(in)                                :: natoms
         LOGICAL, INTENT(in)                                :: gamma_negf

         CHARACTER(LEN=*), PARAMETER :: routineN = 'reademtr'

         INTEGER                                            :: handle

         CALL timeset(routineN, handle)

#if defined(__SMEAGOL)
         CPASSERT(ASSOCIATED(smeagol_control%aux))

         smeagolglobal_gamma_negf = gamma_negf

         IF (smeagol_control%aux%AtmRVCte <= 0) smeagol_control%aux%AtmRVCte = natoms

# 133 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_dsigmade = smeagol_control%aux%dsigmade
# 133 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_calcmpsh = smeagol_control%aux%calcmpsh
# 135 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"

# 137 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_NeneT = smeagol_control%aux%NeneT
# 137 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_rmoinit = smeagol_control%aux%rmoinit
# 137 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_rmolast = smeagol_control%aux%rmolast
# 137 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_rorbinit = smeagol_control%aux%rorbinit
# 137 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_rorblast = smeagol_control%aux%rorblast
# 139 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"

# 141 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_maxkappa = smeagol_control%aux%maxkappa
# 143 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"

# 145 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_TEnergI = smeagol_control%to_smeagol_energy_units*smeagol_control%aux%TEnergI
# 145 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_TEnergF = smeagol_control%to_smeagol_energy_units*smeagol_control%aux%TEnergF
# 145 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_vgate = smeagol_control%to_smeagol_energy_units*smeagol_control%aux%vgate
# 147 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
# 148 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_zgater = smeagol_control%aux%zgater
# 148 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_zgatel = smeagol_control%aux%zgatel
# 148 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_alphag = smeagol_control%aux%alphag
# 150 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"

         coopinfo%ccoop = smeagol_control%aux%COOPCalculate
         coopinfo%nbond = smeagol_control%aux%COOPNumberOfBonds
#else
         CALL cp_abort(__LOCATION__, &
                       "CP2K was compiled with no SMEAGOL support.")
         MARK_USED(smeagol_control)
         MARK_USED(natoms)
         MARK_USED(gamma_negf)
#endif

         CALL timestop(handle)
      END SUBROUTINE reademtr

      SUBROUTINE ReadOptionsNEGF_DFT(smeagol_control, ucell, torqueflag, torquelin)
         TYPE(smeagol_control_type), POINTER                :: smeagol_control
         TYPE(cell_type), POINTER                           :: ucell
         LOGICAL, INTENT(in)                                :: torqueflag, torquelin

         CHARACTER(LEN=*), PARAMETER :: routineN = 'ReadOptionsNEGF_DFT'

         INTEGER                                            :: handle
         REAL(kind=dp), DIMENSION(3)                        :: coord_real, coord_scaled

         CALL timeset(routineN, handle)

#if defined(__SMEAGOL)
         CPASSERT(ASSOCIATED(smeagol_control%aux))

         smeagolglobal_emSTT = torqueflag
         smeagolglobal_emSTTLin = torquelin

         ! In case of the original SIESTA+SMEAGOL, 'TimeReversal' keyword is enabled by default, therefore 'EM.TimeReversal' is also enabled.
         ! In case of this CP2K+SMEAGOL interface, the default value of 'timereversal' variable is .FALSE.
         IF (smeagol_control%aux%timereversal) THEN
            CALL cp_warn(__LOCATION__, &
                         "The SMEAGOL keyword 'EM.TimeReversal' is not supported yet.")
         END IF

# 190 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_timereversal = smeagol_control%aux%timereversal
# 190 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_TRCAddVCDFT = smeagol_control%aux%TRCAddVCDFT
# 190 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_AddVgCompensatingIsolatedLocalCharges = smeagol_control%aux%AddVgCompensatingIsolatedLocalCharges
# 190 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_Add_Rho_Gate = smeagol_control%aux%Add_Rho_Gate
# 190 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_debug_gate = smeagol_control%aux%debug_gate
# 190 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_empdoskso = smeagol_control%aux%empdoskso
# 190 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_emtimings = smeagol_control%aux%emtimings
# 192 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"

# 194 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_ik_select = smeagol_control%aux%ik_select
# 196 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"

# 198 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_Q_gate = smeagol_control%aux%Q_gate
# 200 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"

         ! readoptsnegf_negfmod_plist
         IF (.NOT. smeagol_control%aux%isexplicit_RGlxmin) smeagol_control%aux%RGlxmin = 0.0_dp
         IF (.NOT. smeagol_control%aux%isexplicit_RGlymin) smeagol_control%aux%RGlymin = 0.0_dp
         IF (.NOT. smeagol_control%aux%isexplicit_RGlzmin) smeagol_control%aux%RGlzmin = 0.0_dp
         IF (.NOT. smeagol_control%aux%isexplicit_RGlxmax) THEN
            coord_scaled(:) = (/1.0_dp, 0.0_dp, 0.0_dp/)
            CALL scaled_to_real(coord_real, coord_scaled, ucell)
            smeagol_control%aux%RGlxmax = coord_real(1)
         END IF
         IF (.NOT. smeagol_control%aux%isexplicit_RGlymax) THEN
            coord_scaled(:) = (/0.0_dp, 1.0_dp, 0.0_dp/)
            CALL scaled_to_real(coord_real, coord_scaled, ucell)
            smeagol_control%aux%RGlymax = coord_real(2)
         END IF
         IF (.NOT. smeagol_control%aux%isexplicit_RGlzmax) THEN
            coord_scaled(:) = (/0.0_dp, 0.0_dp, 1.0_dp/)
            CALL scaled_to_real(coord_real, coord_scaled, ucell)
            smeagol_control%aux%RGlzmax = coord_real(3)
         END IF
# 221 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_RGlxmin = smeagol_control%aux%RGlxmin
# 221 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_RGlxmax = smeagol_control%aux%RGlxmax
# 221 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_RGlymin = smeagol_control%aux%RGlymin
# 221 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_RGlymax = smeagol_control%aux%RGlymax
# 221 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_RGlzmin = smeagol_control%aux%RGlzmin
# 221 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_RGlzmax = smeagol_control%aux%RGlzmax
# 223 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"

         ! options to add a Zeeman term to the Hamiltonian
# 226 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_ZeemanBx = smeagol_control%to_smeagol_energy_units*smeagol_control%aux%ZeemanBx
# 226 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_ZeemanBy = smeagol_control%to_smeagol_energy_units*smeagol_control%aux%ZeemanBy
# 226 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_ZeemanBz = smeagol_control%to_smeagol_energy_units*smeagol_control%aux%ZeemanBz
# 228 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
#else
         CALL cp_abort(__LOCATION__, &
                       "CP2K was compiled with no SMEAGOL support.")
         MARK_USED(smeagol_control)
         MARK_USED(ucell)
         MARK_USED(torqueflag)
         MARK_USED(torquelin)
         ! local variables
         MARK_USED(coord_real)
         MARK_USED(coord_scaled)
#endif

         CALL timestop(handle)
      END SUBROUTINE ReadOptionsNEGF_DFT

      SUBROUTINE emtrans_options(smeagol_control, matrix_s, para_env, iter, istep, inicoor, iv, delta, nk)
         TYPE(smeagol_control_type), POINTER                :: smeagol_control
         TYPE(dbcsr_type), INTENT(in), POINTER              :: matrix_s
         TYPE(mp_para_env_type), POINTER                    :: para_env
         INTEGER, INTENT(in)                                :: iter, istep, inicoor, iv
         REAL(kind=dp), INTENT(in)                          :: delta
         INTEGER, INTENT(in)                                :: nk

         CHARACTER(LEN=*), PARAMETER :: routineN = 'emtrans_options'

         CHARACTER(len=default_string_length)               :: actual_val_str, expected_val_str
         INTEGER                                            :: GetRhoSingleLeadDefault, handle, i, iatom, n1, nblkcols_total, &
                                                               NParallelK, NParallelKbuf
         INTEGER, DIMENSION(:), POINTER                     :: col_blk_offset, col_blk_size

         CALL timeset(routineN, handle)

#if defined(__SMEAGOL)
         CPASSERT(ASSOCIATED(smeagol_control%aux))

         CALL dbcsr_get_info(matrix=matrix_s, nblkcols_total=nblkcols_total, &
                             col_blk_size=col_blk_size, col_blk_offset=col_blk_offset)
         ! number of atomic orbitals.
         ! The name n1 is meaningless, but it is used in the original SIESTA's version of emtrans_options() subroutine
         n1 = SUM(col_blk_size(1:nblkcols_total))

         IF ((iter == 1) .AND. (istep == inicoor) .AND. (iv == 0)) THEN

            IF (smeagol_control%aux%gridmethod == smeagol_gridmethod_traditional) THEN
               smeagolglobal_gridmethod = 'Traditional'
            ELSE IF (smeagol_control%aux%gridmethod == smeagol_gridmethod_adaptive) THEN
               smeagolglobal_gridmethod = 'Adaptivegrid'
            ELSE
               smeagolglobal_gridmethod = 'UNKNOWN'
            END IF

            IF (smeagol_control%aux%integraltype == smeagol_integraltype_gauss_legendre) THEN
               smeagolglobal_integraltype = 'gauss-legendre'
            ELSE IF (smeagol_control%aux%integraltype == smeagol_integraltype_gauss_chebyshev) THEN
               smeagolglobal_integraltype = 'gauss-chebyshev'
            ELSE
               smeagolglobal_integraltype = 'UNKNOWN'
            END IF

            smeagolglobal_negf_base_comm = para_env%get_handle()

            IF (MOD(smeagol_control%aux%ndivisions, 2) == 0) THEN
               CALL cp_abort(__LOCATION__, &
                             "AM.NumberDivisions value must be odd.")
            END IF

            ! It seems that 'sigmatodisk' parameter is specific to the SIESTA interface.
            ! Consider setting smeagol_control%aux%sigmatodisk = .FALSE. and remove smeagol_control%aux%storesigma input keyword.
            IF (smeagol_control%aux%storesigma == 2) THEN
               smeagol_control%aux%sigmatodisk = .TRUE.
            ELSE IF (smeagol_control%aux%storesigma == 1) THEN
               smeagol_control%aux%sigmatodisk = .FALSE.
            END IF

            ! Bound states
            !     options:
            !       bs_add    : true => bound states are added
            !                   false=> normal smeagol
            !       bs_method : 0    => calculate bound states with effective Hamiltonian
            !                   1    => calculate bound states by adding a small
            !                           imaginary part to the selfenergies
            IF (smeagol_control%aux%bs_nmid == 0) smeagol_control%aux%bs_nmid = n1/2

            ! SC: Bad practice: real number comparison
            IF (smeagol_control%aux%SigmaWideBand /= 0.0_dp) smeagol_control%aux%m_svdtolzi = 0.0_dp

            IF (smeagol_control%aux%leadspdos) smeagol_control%aux%leadsdos = .TRUE.
            IF (smeagol_control%aux%curr_distKEne) smeagol_control%aux%curr_distK = .TRUE.
            IF (smeagol_control%aux%curr_distK) smeagol_control%aux%curr_dist = .TRUE.

            IF (smeagolglobal_emSTT .AND. smeagolglobal_emSTTLin .OR. smeagol_control%aux%curr_dist) THEN
               smeagol_control%aux%emldos2 = .TRUE.
               IF (smeagol_control%aux%curr_dist) THEN
                  GetRhoSingleLeadDefault = 3
               ELSE
                  GetRhoSingleLeadDefault = -3
               END IF
            ELSE
               GetRhoSingleLeadDefault = 0
            END IF

            ! current-induced forces
            ! The value of 'smeagol_control%emforces' is set in qs_energies().
            ! Calculation of forces is enabled automatically for certain run_types (energy_force, geo_opt, md) and disabled otherwise.
            IF (smeagol_control%aux%curr_dist) THEN
               smeagol_control%emforces = .TRUE.
            END IF

            IF (.NOT. smeagol_control%aux%isexplicit_nprocs_hs) smeagol_control%aux%nprocs_hs = smeagol_control%aux%nprocs_inverse
            smeagolglobal_nprocs_hs = smeagol_control%aux%nprocs_hs
           IF (.NOT. smeagol_control%aux%isexplicit_GetRhoSingleLead) smeagol_control%aux%GetRhoSingleLead = GetRhoSingleLeadDefault

            IF (smeagol_control%aux%MinChannelIndex < 1) smeagol_control%aux%MinChannelIndex = 1
            IF (smeagol_control%aux%MaxChannelIndex < 1) &
               smeagol_control%aux%MaxChannelIndex = smeagol_control%aux%MinChannelIndex + 4

            IF (smeagolglobal_emSTT .AND. smeagolglobal_emSTTLin .AND. smeagol_control%aux%GetRhoSingleLead /= -3) THEN
               CALL cp_warn(__LOCATION__, &
                            "EM.LDOSLeadsProjection should be set to -3. "// &
                            "If SpinTorque and STLinResp are T, otherwise the output "// &
                            "results for the spin transfer torque are incorrect.")
            END IF

            ! NParallelK
            NParallelK = smeagol_control%aux%NParallelK
            IF (MOD(para_env%num_pe, NParallelK) /= 0) then
               CALL cp_warn(__LOCATION__, &
                            "EM.ParallelOverKNum must be a divisor of the total number of "// &
                            "MPI processes used in a run; resetting the value of NParallelK.")
               NParallelKbuf = NParallelK
               DO NParallelK = NParallelKbuf, 1, -1
                  IF (MOD(para_env%num_pe, NParallelK) == 0) EXIT
               END DO
            END IF

            IF (NParallelK > para_env%num_pe) THEN
               CALL cp_warn(__LOCATION__, &
                            "EM.ParallelOverKNum can not be larger than the total number of "// &
                            "MPI processes used in a run; resetting the value of NParallelK.")
               NParallelK = -1
            END IF

            IF (NParallelK > nk) THEN
               CALL cp_warn(__LOCATION__, &
                            "EM.ParallelOverKNum can not be larger than the total number of "// &
                            "k-points used in a run; resetting the value of NParallelK.")
               NParallelK = -1
            END IF

            IF (NParallelK == -1) THEN
               DO NParallelK = nk, 1, -1
                  IF (MOD(para_env%num_pe, NParallelK) == 0) EXIT
               END DO
            END IF

            smeagol_control%aux%NParallelK = NParallelK

            IF (smeagol_control%aux%empdosk) smeagol_control%aux%empdos = .TRUE.
            IF (smeagol_control%aux%emldos2) smeagol_control%aux%emdos = .TRUE.
            IF (smeagol_control%aux%TransmissionChannels) smeagol_control%aux%emdos = .TRUE.
            IF (smeagol_control%aux%TransmissionMatrix) smeagol_control%aux%emdos = .TRUE.
            IF (smeagol_control%aux%curr_dist) smeagol_control%aux%emdos = .TRUE.
            IF (smeagol_control%aux%empdos) smeagol_control%aux%emdos = .TRUE.
            IF (smeagol_control%aux%m_skipsvd < 2.0_dp) smeagol_control%aux%m_skipsvd = 10.0_dp

            IF (smeagol_control%aux%CallImpuritySolver) smeagol_control%aux%ComputeImpurityGfMatsubara = .TRUE.

# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_pdosgs = smeagol_control%aux%pdosgs
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_skipright = smeagol_control%aux%skipright
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_sigmatodisk = smeagol_control%aux%sigmatodisk
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_bs_add = smeagol_control%aux%bs_add
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_bs_writetrc = smeagol_control%aux%bs_writetrc
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_writetk = smeagol_control%aux%writetk
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_setene = smeagol_control%aux%setene
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_overwritehs = smeagol_control%aux%overwritehs
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_transmembed = smeagol_control%aux%transmembed
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_writeevsigma = smeagol_control%aux%writeevsigma
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_skiptransm = smeagol_control%aux%skiptransm
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_deauto = smeagol_control%aux%deauto
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_geterrsigma = smeagol_control%aux%geterrsigma
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_getsigma = smeagol_control%aux%getsigma
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_trcef = smeagol_control%aux%trcef
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_RhoSetZeroIfHZero = smeagol_control%aux%RhoSetZeroIfHZero
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_m_usehinv = smeagol_control%aux%m_usehinv
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_m_usevinv = smeagol_control%aux%m_usevinv
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_m_callsvd = smeagol_control%aux%m_callsvd
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_m_complexbands = smeagol_control%aux%m_complexbands
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_m_dosleads = smeagol_control%aux%m_dosleads
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_leadsdos = smeagol_control%aux%leadsdos
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_leadspdos = smeagol_control%aux%leadspdos
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_emldos = smeagol_control%aux%emldos
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_emldos2 = smeagol_control%aux%emldos2
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_curr_distKEne = smeagol_control%aux%curr_distKEne
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_curr_distK = smeagol_control%aux%curr_distK
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_curr_dist = smeagol_control%aux%curr_dist
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_curr_distTRC = smeagol_control%aux%curr_distTRC
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_em_NonSCF = smeagol_control%aux%em_NonSCF
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_TransmissionRL = smeagol_control%aux%TransmissionRL
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_emSTTk = smeagol_control%aux%emSTTk
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_GetT0S = smeagol_control%aux%GetT0S
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_TransmissionChannels = smeagol_control%aux%TransmissionChannels
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_TransmissionChannelsWFS = smeagol_control%aux%TransmissionChannelsWFS
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_TransmissionMatrix = smeagol_control%aux%TransmissionMatrix
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_TransmissionMatrixWFS = smeagol_control%aux%TransmissionMatrixWFS
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_TransmissionMatrixPDOS = smeagol_control%aux%TransmissionMatrixPDOS
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_EM_EndCode1 = smeagol_control%aux%EM_EndCode1
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_TransmOverk = smeagol_control%aux%TransmOverk
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_emdos = smeagol_control%aux%emdos
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_empdos = smeagol_control%aux%empdos
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_empdosk = smeagol_control%aux%empdosk
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_WriteIkTrcK = smeagol_control%aux%WriteIkTrcK
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_cbspart = smeagol_control%aux%cbspart
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_evec = smeagol_control%aux%evec
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_negfon = smeagol_control%aux%negfon
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_outinfo = smeagol_control%aux%outinfo
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_WriteNk = smeagol_control%aux%WriteNk
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_Set_RhoBoundary_Leads = smeagol_control%aux%Set_RhoBoundary_Leads
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_Set_RhoBoundaryOverlap_Leads = smeagol_control%aux%Set_RhoBoundaryOverlap_Leads
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_Set_HBoundary_Leads = smeagol_control%aux%Set_HBoundary_Leads
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_Set_HLR_Zero = smeagol_control%aux%Set_HLR_Zero
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_SkipNonEquilibriumRho = smeagol_control%aux%SkipNonEquilibriumRho
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_SkipEquilibriumRho = smeagol_control%aux%SkipEquilibriumRho
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_ComputeImpurityGfMatsubara = smeagol_control%aux%ComputeImpurityGfMatsubara
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_PrintImpurityGfMatsubara = smeagol_control%aux%PrintImpurityGfMatsubara
# 396 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_CallImpuritySolver = smeagol_control%aux%CallImpuritySolver
# 398 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
            smeagolglobal_emforces = smeagol_control%emforces

            ! emtoptions_local_ilist, emtoptions_local_explicit_ilist
            IF (.NOT. smeagol_control%aux%isexplicit_Sigma_NxLeft) smeagol_control%aux%Sigma_NxLeft = smeagol_control%aux%Sigma_Nx
            IF (.NOT. smeagol_control%aux%isexplicit_Sigma_NyLeft) smeagol_control%aux%Sigma_NyLeft = smeagol_control%aux%Sigma_Ny
            IF (.NOT. smeagol_control%aux%isexplicit_Sigma_NxRight) smeagol_control%aux%Sigma_NxRight = smeagol_control%aux%Sigma_Nx
            IF (.NOT. smeagol_control%aux%isexplicit_Sigma_NyRight) smeagol_control%aux%Sigma_NyRight = smeagol_control%aux%Sigma_Ny

            smeagolglobal_ndivxy(1) = smeagol_control%aux%Sigma_Nx
            smeagolglobal_ndivxy(2) = smeagol_control%aux%Sigma_Ny
            smeagolglobal_ndivxyNL(1, 1) = smeagol_control%aux%Sigma_NxLeft
            smeagolglobal_ndivxyNL(1, 2) = smeagol_control%aux%Sigma_NyLeft
            smeagolglobal_ndivxyNL(2, 1) = smeagol_control%aux%Sigma_NxRight
            smeagolglobal_ndivxyNL(2, 2) = smeagol_control%aux%Sigma_NyRight

            CALL SetOptionsSelfEnergies(smeagolglobal_ndivxyNL, 2)

# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_maxdepth = smeagol_control%aux%maxdepth
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_ndivisions = smeagol_control%aux%ndivisions
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_storesigma = smeagol_control%aux%storesigma
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_bs_method = smeagol_control%aux%bs_method
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_bs_nmid = smeagol_control%aux%bs_nmid
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_NRunSigmaMax = smeagol_control%aux%NRunSigmaMax
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_bsrun = smeagol_control%aux%bsrun
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_bsskip = smeagol_control%aux%bsskip
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_bseskip = smeagol_control%aux%bseskip
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_bssc = smeagol_control%aux%bssc
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_inversion_solver = smeagol_control%aux%inversion_solver
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_onekp = smeagol_control%aux%onekp
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_nbss = smeagol_control%aux%nbss
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_nSplit = smeagol_control%aux%nSplit
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_TransmissionChannelsWFSSkipEne = smeagol_control%aux%TransmissionChannelsWFSSkipEne
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_TransmissionChannelsWFSSkipKP = smeagol_control%aux%TransmissionChannelsWFSSkipKP
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_TransmissionMatrixPDOSNWrite = smeagol_control%aux%TransmissionMatrixPDOSNWrite
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_TransmissionMatrixiSetPhase = smeagol_control%aux%TransmissionMatrixiSetPhase
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_MinChannelIndex = smeagol_control%aux%MinChannelIndex
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_MaxChannelIndex = smeagol_control%aux%MaxChannelIndex
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_N_Replace_L = smeagol_control%aux%N_Replace_L
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_N_Replace_R = smeagol_control%aux%N_Replace_R
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_curr_nb1 = smeagol_control%aux%curr_nb1
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_curr_nb2 = smeagol_control%aux%curr_nb2
# 416 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_NParallelK = smeagol_control%aux%NParallelK
# 418 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"

# 420 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_GetRhoSingleLead = smeagol_control%aux%GetRhoSingleLead
# 422 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"

# 424 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_sigma_method = smeagol_control%aux%sigma_method
# 426 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"

# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_bs_tol = smeagol_control%aux%bs_tol
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_bs_min  = smeagol_control%aux%bs_min 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_HSTol  = smeagol_control%aux%HSTol 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_deltaimag  = smeagol_control%aux%deltaimag 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_deltaini  = smeagol_control%aux%deltaini 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_deltatode  = smeagol_control%aux%deltatode 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_critam  = smeagol_control%aux%critam 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_setemin  = smeagol_control%aux%setemin 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_setemax  = smeagol_control%aux%setemax 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_tolab  = smeagol_control%aux%tolab 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_weightrho  = smeagol_control%aux%weightrho 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_ThetaLeadsL  = smeagol_control%aux%ThetaLeadsL 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_PhiLeadsL  = smeagol_control%aux%PhiLeadsL 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_ThetaLeadsR  = smeagol_control%aux%ThetaLeadsR 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_PhiLeadsR  = smeagol_control%aux%PhiLeadsR 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_deltaimagtrc  = smeagol_control%aux%deltaimagtrc 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_m_tolki  = smeagol_control%aux%m_tolki 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_m_svdtolmax  = smeagol_control%aux%m_svdtolmax 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_m_svdtolmin  = smeagol_control%aux%m_svdtolmin 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_m_dsigmamax  = smeagol_control%aux%m_dsigmamax 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_m_rnoise  = smeagol_control%aux%m_rnoise 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_m_skipsvd  = smeagol_control%aux%m_skipsvd 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_m_svdtolzi  = smeagol_control%aux%m_svdtolzi 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_SigmaWideBand  = smeagol_control%aux%SigmaWideBand 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_emSTTkScale  = smeagol_control%aux%emSTTkScale 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_nlSetZeroRatio  = smeagol_control%aux%nlSetZeroRatio 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_nrSetZeroRatio  = smeagol_control%aux%nrSetZeroRatio 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_curr_fl_L  = smeagol_control%aux%curr_fl_L 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_curr_fr_L  = smeagol_control%aux%curr_fr_L 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_curr_fl_R  = smeagol_control%aux%curr_fl_R 
# 428 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_curr_fr_R  = smeagol_control%aux%curr_fr_R 
# 430 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"

            ! +++ bound states
            IF (.NOT. smeagol_control%aux%isexplicit_deltamin) smeagol_control%aux%deltamin = delta

# 435 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_deltamin = smeagol_control%aux%deltamin
# 437 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"

# 439 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_tolsigma = smeagol_control%to_smeagol_energy_units*smeagol_control%aux%tolsigma
# 439 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"
               smeagolglobal_trcde = smeagol_control%to_smeagol_energy_units*smeagol_control%aux%trcde
# 441 "/builddir/build/BUILD/cp2k-0.0.0-build/cp2k-0.0.0/src/smeagol_emtoptions.F"

            ! At present read_options_ImpuritySolver() is a dummy libsmeagol.a subroutine,
            ! so we do not call it
            !IF (smeagol_control%ComputeImpurityGfMatsubara) THEN
            !   CALL read_options_ImpuritySolver(CallImpuritySolver,n1)
            !END IF
         END IF

         ! *** bound states (re-implemented ReadSpeciesBS() and ReadBSSubSystemBoundaries() subroutines)

         ! bound- state-related global allocatable arrays
         ALLOCATE (smeagolglobal_deltabss_bs(smeagol_control%aux%nbss))
         ALLOCATE (smeagolglobal_nebss_bs(smeagol_control%aux%nbss, 2))
         ALLOCATE (smeagolglobal_orbital_BS(n1))

         ! BS.SubSystemsDelta
         IF (ALLOCATED(smeagol_control%aux%deltabss_bs)) THEN
            smeagolglobal_deltabss_bs(:) = smeagol_control%aux%deltabss_bs(:)
         ELSE
            smeagolglobal_deltabss_bs(:) = smeagol_control%aux%deltamin
         END IF

         ! BS.SubSystemsBoundaries
         IF (ALLOCATED(smeagol_control%aux%nebss_bs)) THEN
            IF (MAXVAL(smeagol_control%aux%nebss_bs) > n1) THEN
               CALL integer_to_string(MAXVAL(smeagol_control%aux%nebss_bs), actual_val_str)
               CALL integer_to_string(n1, expected_val_str)
               CALL cp_abort(__LOCATION__, &
                             "The largest index in BS.SubSystemsBoundaries section ("//TRIM(actual_val_str)// &
                             ") exceeds the number of atomic orbitals ("//TRIM(expected_val_str)//").")
            END IF
            smeagolglobal_nebss_bs(:, :) = smeagol_control%aux%nebss_bs(:, :)
         ELSE
            smeagolglobal_nebss_bs(1, 1) = 1
            smeagolglobal_nebss_bs(1, 2) = n1/smeagol_control%aux%nbss
            DO i = 2, smeagol_control%aux%nbss
               smeagolglobal_nebss_bs(i, 1) = smeagolglobal_nebss_bs(i - 1, 2) + 1
               smeagolglobal_nebss_bs(i, 2) = i*n1/smeagol_control%aux%nbss
            END DO
            smeagolglobal_nebss_bs(smeagol_control%aux%nbss, 2) = n1
         END IF

         ! AM.AtomListBS
         IF (ALLOCATED(smeagol_control%aux%atomlist_bs)) THEN
            IF (MAXVAL(smeagol_control%aux%atomlist_bs) > nblkcols_total) THEN
               CALL integer_to_string(MAXVAL(smeagol_control%aux%atomlist_bs), actual_val_str)
               CALL integer_to_string(nblkcols_total, expected_val_str)
               CALL cp_abort(__LOCATION__, &
                             "The largest atomic index in AM.AtomListBS keyword ("//TRIM(actual_val_str)// &
                             ") exceeds the number of atoms ("//TRIM(expected_val_str)//") in the extended molecule.")
            END IF

            smeagolglobal_orbital_BS(:) = .FALSE.
            DO i = 1, SIZE(smeagol_control%aux%atomlist_bs)
               iatom = smeagol_control%aux%atomlist_bs(i)
               smeagolglobal_orbital_BS(col_blk_offset(iatom):col_blk_offset(iatom) + col_blk_size(iatom) - 1) = .TRUE.
            END DO
         ELSE
            smeagolglobal_orbital_BS(:) = .TRUE.
         END IF
#else
         CALL cp_abort(__LOCATION__, &
                       "CP2K was compiled with no SMEAGOL support.")
         MARK_USED(smeagol_control)
         MARK_USED(matrix_s)
         MARK_USED(para_env)
         MARK_USED(iter)
         MARK_USED(istep)
         MARK_USED(inicoor)
         MARK_USED(iv)
         MARK_USED(delta)
         MARK_USED(nk)
         ! local variables
         MARK_USED(actual_val_str)
         MARK_USED(col_blk_offset)
         MARK_USED(col_blk_size)
         MARK_USED(expected_val_str)
         MARK_USED(GetRhoSingleLeadDefault)
         MARK_USED(i)
         MARK_USED(iatom)
         MARK_USED(n1)
         MARK_USED(nblkcols_total)
         MARK_USED(NParallelK)
         MARK_USED(NParallelKbuf)
#endif

         CALL timestop(handle)
      END SUBROUTINE emtrans_options

      SUBROUTINE emtrans_deallocate_global_arrays()

#if defined(__SMEAGOL)
         IF (ALLOCATED(smeagolglobal_deltabss_bs)) DEALLOCATE (smeagolglobal_deltabss_bs)
         IF (ALLOCATED(smeagolglobal_nebss_bs)) DEALLOCATE (smeagolglobal_nebss_bs)
         IF (ALLOCATED(smeagolglobal_orbital_BS)) DEALLOCATE (smeagolglobal_orbital_BS)
#endif

      END SUBROUTINE emtrans_deallocate_global_arrays

   END MODULE smeagol_emtoptions

